#!/usr/bin/perl

# path to config file
$config="killer.cfg";





###############################################################################
### Programm #################################################### do't edit ###
###############################################################################

$ver="BSO Killer v0.2 (c) Sln !";

# check config
open(CFG,"< $config") or die "$config: $!";

$address=$inbound=$outbound=$passwd=$logfile=$notice=$areafix=$allfix=$delremove=
$deldup=$keeplo=$deltic=$deloldbsy=$reportfile=$testmode=$name_af=$name_ff=undef;
undef %link;
$i=0;

while(<CFG>){
$address=$1	if /^address\s+(\S+)$/i;
$inbound=$1	if /^inbound\s+(\S+)$/i;
$outbound=$1	if /^outbound\s+(\S+)$/i;
$passwd=$1	if /^passwd\s+(\S+)$/i;
$reportfile=$1	if /^report\s+(\S+)$/i;
$logfile=$1	if /^logfile\s+(\S+)$/i;
$notice=$1	if /^notice\s+(\S+)$/i;
$name_af=$1	if /^name_areafix\s+(.+)$/i;
$name_ff=$1	if /^name_filefix\s+(.+)$/i;
$areafix=$1	if /^areafix\s+(\S+)$/i;
$allfix=$1	if /^allfix\s+(\S+)$/i;
$delremove=1	if /^delremove$/i;
$deldup=1	if /^deldup$/i;
$keeplo=1	if /^keeplo$/i;
$deltic=1	if /^deltic$/i;
$testmode=1	if /^testmode$/i;
$deloldbsy=$1	if /^deloldbsy\s+(\d+)$/i;
$link{$i++}=[$1,$2,$3,$4,$5,$6,$7,$8,$9,$10] if /^([\d:\/\.]+)\s+(\w+)\s+(\d+)\s+(\w+)\s+(\d+)\s+(\S+)\s+(\w+)\s+(\d+)\s+(\S+)\s+([\w\-]+)\s*$/i;
}

die "Config have error, fix it."
unless $address and $inbound and $outbound and $passwd and $logfile and $notice and
       $name_af and $name_ff and $areafix and $allfix and $reportfile and %link;


uplog("Starting $ver");
uplog("Check config");


### parse note ###
$note=undef;
 open(NOTE,"< $notice") or err("$notice: $!");
   while(<NOTE>){
    s/[\r\n]+$//;
    $note.="$_\r";
   }
 close(NOTE);


undef %n;
undef %a;
undef %f;
undef %k;
undef %m;

foreach $i (sort {$a<=>$b} keys %link){

%{$n{$i}}=map {lc($_),''} split //,$link{$i}[1];
$n{$i}{'days'}=$link{$i}[2];

%{$a{$i}}=map {lc($_),''} split //,$link{$i}[3];
$a{$i}{'days'}=$link{$i}[4];
$a{$i}{'pass'}=getpass($i,$link{$i}[5]);

%{$f{$i}}=map {lc($_),''} split //,$link{$i}[6];
$f{$i}{'days'}=$link{$i}[7];
$f{$i}{'pass'}=getpass($i,$link{$i}[8]);

%{$k{$i}}=map {lc($_),''} split //,$link{$i}[9];

err("Check netmail keys for $link{$i}[0]")	if not (exists $n{$i}{'e'} or exists $n{$i}{'c'});
err("Check arcmail keys for $link{$i}[0]")	if not (exists $a{$i}{'c'} or exists $a{$i}{'d'} or exists $a{$i}{'e'});
err("Check tics keys for $link{$i}[0]")		if not (exists $f{$i}{'c'} or exists $f{$i}{'d'} or exists $f{$i}{'e'});
err("Check action for $link{$i}[0]")		if not (exists $k{$i}{'o'} or exists $k{$i}{'k'} or exists $k{$i}{'-'});
}



foreach $n (sort {$a<=>$b} keys %link){

undef @rmfile;

uplog("Work with $link{$n}[0]");

($p,$f)=getpath($link{$n}[0]);


### check bsy flag ############################################################

if(my $t=(stat("$p/$f"."bsy"))[9]){
 if(!$testmode and $deloldbsy and time-$t > 3600*$deloldbsy){
  uplog("Delete old busy flag");
  unlink("$p/$f"."bsy") or err("bsy: $!");
 }else{
  uplog("Skip (busy)");
  next;
 }
}



### NETMAIL ###################################################################

foreach(getfile("out|cut|hut|iut")){
 my ($s,$t)=(stat("$p/$_"))[7,9];
  if(exists $n{$n}{'c'} and time-$t > $n{$n}{'days'}*86400){
   $m{$n}{'n'}.="$_\t$s\t$t\n";
   push @rmfile, "$p/$_";
   uplog("Old netmail file      -> '$p/$_'");
  }
}




### ?LO #######################################################################

foreach $f (getfile("clo|hlo|flo|ilo|dlo")){

undef %lo;
$i=0;
 open(LO,"< $p/$f") or err("$p/$f: $!");
  while(<LO>){ chomp($lo{$i++}=$_) }
 close(LO);

$j=scalar keys %lo;




### remove not exist files ####################################################
if($delremove){
 foreach(keys %lo){
  $lo{$_}=~/^[\^\#\~]*(.+)$/;
   unless(-f $1){
    uplog("Remove empty link     -> '$lo{$_}'");
    delete $lo{$_};
   }
 }
}


### delete dupe ###############################################################
if($deldup){
undef %dup;
 foreach(sort {$b<=>$a} keys %lo){
  $lo{$_}=~/^[\^\#\~]*(.+)$/;
   if(exists $dup{$1}){
    uplog("Remove duplicate link -> '$lo{$_}'");
    delete $lo{$_};
   }
   $dup{$1}='';
 }
}



### ARCMAIL ###################################################################

undef %af;
undef %of;
undef %sf;

foreach(keys %lo){
 if($lo{$_}=~/^[\^\#\~](.*)\/(\w{1,8}\.(su|mo|tu|we|th|fr|sa)\w)$/i){
  my ($s,$t)=(stat("$1/$2"))[7,9];
  $sf{$_}="$2\t$s\t$t\n";
  $af{$_}="$1/$2";
  $of{$_}="$1/$2" if time-$t > $a{$n}{'days'}*86400 and (exists $a{$n}{'c'} or exists $a{$n}{'d'});
 }
}



if(%of){
 if(exists $a{$n}{'d'}){
   foreach(sort {$a<=>$b} keys %af){
    push @rmfile, $af{$_};
    uplog("Remove old arc file   -> '$af{$_}'");
    delete $lo{$_};
    $m{$n}{'a'}.=$sf{$_};
   }
 }elsif(exists $a{$n}{'c'}){
   foreach(sort {$a<=>$b} keys %of){
    push @rmfile, $of{$_};
    uplog("Remove old arc file   -> '$of{$_}'");
    delete $lo{$_};
    $m{$n}{'a'}.=$sf{$_};
   }
 }
}



### TIC #######################################################################

undef %at;
undef %ot;
undef %st;
undef %df;
undef %ff;

foreach my $c (keys %lo){
 if($lo{$c}=~/^[\^\#\~](.*)\/(\w{1,8}\.tic)$/i){
 my ($tp,$tf)=($1,$2);
  open(TIC,"$tp/$tf") or err("$tp/$tf: $!");
   my $filename;
   while(<TIC>){ $filename=$1 if /^file\s+(\S+)/i }
  close(TIC);

   next unless length($filename);

   foreach(keys %lo){
    if($lo{$_}=~/^[^\^\#\~]?.+\/\Q$filename\E$/){
     $df{$c}=$_;
     last;
    }
   }

### remove tic without file ###################################################
if($deltic and not exists $df{$c}){
 push @rmfile, "$tp/$tf";
 uplog("Remove tic w/o file   -> '$tp/$tf'");
 delete $lo{$c};
 next;
}

    my ($s,$t)=(stat("$tp/$tf"))[7,9];
    $at{$c}="$tp/$tf";
    $ot{$c}="$tp/$tf" if time-$t > $f{$n}{'days'}*86400 and (exists $f{$n}{'c'} or exists $f{$n}{'d'});

 }
}


if(%ot){
 if(exists $f{$n}{'d'}){
   foreach(sort {$a<=>$b} keys %at){
    push @rmfile, $at{$_};
    uplog("Remove old tic file   -> '$at{$_}'");
    uplog("Remove link from tic  -> '$lo{$df{$_}}'");
    delete $lo{$df{$_}};
    delete $lo{$_};
    $m{$n}{'f'}.=$st{$_};
   }
 }elsif(exists $f{$n}{'c'}){
   foreach(sort {$a<=>$b} keys %ot){
    push @rmfile, $ot{$_};
    uplog("Remove old tic file   -> '$ot{$_}'");
    uplog("Remove link from tic  -> '$lo{$df{$_}}'");
    delete $lo{$df{$_}};
    delete $lo{$_};
    $m{$n}{'f'}.=$st{$_};
   }
 }
}



### REMOVE FILES ##############################################################
if(!$testmode and @rmfile){
  unlink(@rmfile) or uplog("Can't remove some file");
  uplog("Remove files");
}


### write ?lo file ############################################################
if(scalar keys %lo != $j and !$testmode){
 open(LO,">$p/$f") or err("$p/$f: $!");
  print LO map {"$lo{$_}\n"} sort {$a<=>$b} keys %lo;
 close(LO);
uplog("Write                 -> '$p/$f'");
}


# unlink empty *.?lo
if(scalar keys %lo == 0 and !$keeplo and !$testmode){
 uplog("Unlink empty          -> '$p/$f'");
 unlink("$p/$f") or err("$p/$f: $!");
}

}


### Send mail #################################################################
  unless($testmode){
  uplog("Sent $areafix to $name_af"), pkt($link{$n}[0],"Point",$address,$name_af,$a{$n}{'pass'},$areafix) if exists $m{$n}{'a'} and exists $a{$n}{'f'};
  uplog("Sent $allfix to $name_ff"),  pkt($link{$n}[0],"Point",$address,$name_ff,$a{$n}{'pass'},$allfix)  if exists $m{$n}{'f'} and exists $f{$n}{'f'};
  uplog("Sent notice"),               pkt($address,    "Robot",$link{$n}[0],"Point","notice",  $note)     if (exists $m{$n}{'a'} or exists $m{$n}{'f'}) and exists $k{$n}{'k'};
 }
}





### make report file ##########################################################
$report=undef;

foreach $n (sort {$a<=>$b} keys %link){
 if((exists $m{$n}{'n'} or exists $m{$n}{'a'} or exists $m{$n}{'f'}) and exists $k{$n}{'o'}){
  ($ts,$tf)=(0,0);
  $report.="\n>$link{$n}[0]\n";
  my $str =$m{$n}{'n'} if exists $m{$n}{'n'};
     $str.=$m{$n}{'a'} if exists $m{$n}{'a'};
     $str.=$m{$n}{'f'} if exists $m{$n}{'f'};
  
  foreach (split /\n+/,$str){
    my @t=split(/\t/,$_);
     $tf++;
     $ts+=$t[1];
    $report.=sprintf("% 13s",$t[0]).sprintf("% 8s", $t[1])." (".sprintf("% 2s",int ((time-$t[2])/(60*60*24))+1)." day)\n";
  }
    my $num='file';
    $num.='s' if $tf > 1;
    $report.=" ".("-"x30)."\n $tf files at $ts bytes\n";
 }
}

if($report){
 open(REP,"> $reportfile") or err("$reportfile: $!");
  print REP "$report\n\n$ver\n";
 close(REP);
  uplog("Make report file");
}



### FINISH ####################################################################
if($report){
 uplog("Exit 5 (ok)\n");
 exit(5);
}else{
 uplog("Exit 0 (ok)\n");
 exit(0);
}



### sub programm ##############################################################
sub getpass {
my ($i,$symb)=@_;
 return '' if $symb eq "-";
 return $symb if $symb ne "-" and $symb ne "!";
open(PWD,"< $passwd") or err("$passwd: $!");
 my $pass;
  while(<PWD>){ $pass=$1 if /^password\s+\Q$link{$i}[0]\E\s+(\S+)/i }
close(PWD);
 $pass ? return($pass) : err("Password for $link{$i}[0] not found");
}



sub getpath {
my $adr=shift;
 return("$outbound/".sprintf("%04x%04x.pnt",$1,$2),sprintf("0000%04x.",$3)) if $adr=~/^\d+:(\d+)\/(\d+)\.(\d+)$/;
 return("$outbound",sprintf("%04x%04x.",$1,$2)) if $adr=~/^\d+:(\d+)\/(\d+)$/;
err("Wrong address $adr");
}



sub getfile {
my $ext=shift;
 opendir(DIR,$p) or uplog("$p: $!");
  my @file=grep{-f "$p/$_" and $_=~/^\Q$f\E($ext)$/i} readdir(DIR);
 closedir(DIR);
return(@file);
}



sub pkt {
my ($afrom,$nfrom,$ato,$nto,$subj,$body)=@_;
$pktpass=undef;

my @f=split /[:.\/]/,$afrom;
my @t=split /[:.\/]/,$ato;
$f[3]=0 if !$f[3];
$t[3]=0 if !$t[3];

my @d=localtime;
my @m=("Jan","Feb","Mar","Apr","May","Jun","Jul","Aug","Sep","Oct","Nov","Dec");

my $header =pack("vvvvvvvvvvvvvA8vvvvvvvvvvVvvvvvvv",
	    $f[2],$t[2],$d[5]+1900,$d[4],$d[3],$d[2],$d[1],$d[0],
	    0,2,$f[1],$t[1],254,$pktpass,$f[0],$t[0],0,256,2304,1,
	    $f[0],$t[0],$f[3],$t[3],0,2,$f[2],$t[2],$f[1],$t[1],1,0);

my $head=sprintf("%02d",$d[3])." $m[$d[4]] ".(substr $d[5],-2)."  ".sprintf("%02d:%02d:%02d",$d[2],$d[1],$d[0])."\x00$nto\x00$nfrom\x00$subj\x00";

my $cluge ="\x01INTL $t[0]:$t[1]/$t[2] $f[0]:$f[1]/$f[2]\x0D";
$cluge.="\x01TOPT $t[3]\x0D" if $t[3] != 0;
$cluge.="\x01FMPT $f[3]\x0D" if $f[3] != 0;
$cluge.="\x01MSGID: $afrom ".sprintf("%lx",time)."\x0D";

$body.="\x0D--- $ver\x0D\x00\x00\x00";

my $pktname=sprintf("%lx",time-rand('999999')).".pkt";

open(PKT,"> $inbound/$pktname") or err("$inbound/$pktname: $!");
 print PKT $header.$head.$cluge.$body;
close(PKT);
}



sub err {
 uplog("$_[0]");
 uplog("Exit 1 (err)\n");
 exit(1);
}



sub uplog{
my @t=localtime();
open(LOG, ">> $logfile") or die "$logfile: $!";
 print LOG sprintf("%02d/%02d/%02d %02d:%02d:%02d",$t[3],$t[4],substr($t[5],-2),$t[2],$t[1],$t[0])." killer [$$] $_[0]\n";
close(LOG);
}
